package com.metaonewalletreactnativesdk

import com.facebook.react.bridge.Arguments
import com.facebook.react.bridge.WritableArray
import com.facebook.react.bridge.WritableMap
import org.json.JSONArray
import org.json.JSONObject

class Helper {

  private fun jsonToWritableArray(jsonArray: JSONArray): WritableArray {
    val writableArray: WritableArray = Arguments.createArray()

    for (i in 0 until jsonArray.length()) {
      when (val value = jsonArray[i]) {
        is String -> writableArray.pushString(value)
        is Int -> writableArray.pushInt(value)
        is Double -> writableArray.pushDouble(value)
        is Boolean -> writableArray.pushBoolean(value)
        is JSONObject -> writableArray.pushMap(stringToMap(value.toString()))
        is JSONArray -> writableArray.pushArray(jsonToWritableArray(value))
        else -> writableArray.pushString(value.toString())
      }
    }

    return writableArray
  }
  fun stringToMap(jsonString: String): WritableMap {
    val jsonObject = JSONObject(jsonString)
    val writableMap = Arguments.createMap()
    for (key in jsonObject.keys()) {
      when (val value = jsonObject[key]) {
        is String -> writableMap.putString(key, value)
        is Int -> writableMap.putInt(key, value)
        is Double -> writableMap.putDouble(key, value)
        is Boolean -> writableMap.putBoolean(key, value)
        is JSONObject -> writableMap.putMap(
          key,
          stringToMap(value.toString()),
        )
        is JSONObject -> writableMap.putMap(
          key,
          stringToMap(value.toString()),
        )
        is JSONArray -> writableMap.putArray(
          key,
          jsonToWritableArray(value),
        )
        else -> writableMap.putString(key, value.toString())
      }
    }
    return writableMap
  }
}
