package com.metaonewalletreactnativesdk

import com.facebook.react.bridge.Promise
import com.google.gson.Gson
import ventures.aag.metaonesdk.models.ErrorResponse
import ventures.aag.metaonesdk.models.M1EnqueueCallback

class PromiseCallback<T>(private val promise: Promise) : M1EnqueueCallback<T>() {
  override fun onSuccess(response: T) {
    val result: Any = when (response) {
      is String -> response
      is Boolean -> response
      is Number -> response
      else -> Helper().stringToMap(Gson().toJson(response))
    }
    promise.resolve(result)
  }

  override fun onError(errorBody: ErrorResponse) {
    promise.reject(ErrorResponse.toThrowable(errorBody))
  }

  override fun onFailure(message: String) {
    promise.reject(Throwable(message))
  }
}
