import Foundation


class Helper {
    func toDictionary(text: String) -> [String: Any]? {
        if let data = text.data(using: .utf8) {
            do {
                return try JSONSerialization.jsonObject(with: data, options: []) as? [String: Any]
            } catch {
                print(error.localizedDescription)
            }
        }
        return nil
    }
    
    func toString(dictionary: NSDictionary) -> String? {
        do {
            let jsonData = try JSONSerialization.data(withJSONObject: dictionary, options: [])
            if let jsonString = String(data: jsonData, encoding: .utf8) {
                return jsonString
            }
        } catch {
            print("Error converting NSDictionary to JSON string: \(error.localizedDescription)")
        }
        return nil
    }
    
    func stringify(data: Encodable) -> String? {
        let encoder = JSONEncoder()
        do {
            let jsonData = try encoder.encode(data)
            let jsonString = String(data: jsonData, encoding: .utf8)
            return jsonString
        } catch {
            print("Error encoding data: \(error)")
            return nil
        }
    }
}
