#import <React/RCTBridgeModule.h>

@interface RCT_EXTERN_MODULE(MetaoneWalletReactNativeSdk, NSObject)

RCT_EXTERN_METHOD(initialize:(NSDictionary *)sdkConfig
                  resolve:(RCTPromiseResolveBlock)resolve
                  reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(getSessionActivityStatus:(RCTPromiseResolveBlock)resolve reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(loginWithSSO:(NSString *)accessToken
                  resolve:(RCTPromiseResolveBlock)resolve
                  reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(getExpireAt:(RCTPromiseResolveBlock)resolve reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(refreshSession:(RCTPromiseResolveBlock)resolve reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(openWallet:(RCTPromiseResolveBlock)resolve reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(isSignatureSet:(RCTPromiseResolveBlock)resolve reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(sendTransaction:(NSDictionary *)wallet
                  address:(NSString *)address
                  amount:(NSString *)amount
                  asset:(NSDictionary *)asset
                  memo:(NSString *)memo
                  personalNote:(NSString *)personalNote
                  resolve:(RCTPromiseResolveBlock)resolve
                  reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(getColorsScheme:(RCTPromiseResolveBlock)resolve reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(setColorsScheme:(NSDictionary *)colors)

RCT_EXTERN_METHOD(getCurrentLanguage:(RCTPromiseResolveBlock)resolve reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(setCurrentLanguage:(NSString *)locale)

RCT_EXTERN_METHOD(getWallets:(RCTPromiseResolveBlock)resolve reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(getCurrencies:(RCTPromiseResolveBlock)resolve reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(getTransactions:(NSString *)walletId
                  assetRef:(NSString *)assetRef
                  bip44:(NSString *)bip44
                  tokenAddress:(NSString *)tokenAddress
                  limit:(NSString *)limit
                  offset:(NSString *)offset
                  resolve:(RCTPromiseResolveBlock)resolve
                  reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(getNFTs:(NSString *)walletId
                  searchString:(NSString *)searchString
                  limit:(NSString *)limit
                  offset:(NSString *)offset
                  resolve:(RCTPromiseResolveBlock)resolve
                  reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(getUserContacts:(RCTPromiseResolveBlock)resolve reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(getUserContactWithId:(NSString *)contactId
                  resolve:(RCTPromiseResolveBlock)resolve
                  reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(addUserContact:(NSDictionary *)contact
                  resolve:(RCTPromiseResolveBlock)resolve
                  reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(updateUserContact:(NSString *)contactId
                  contact:(NSDictionary *)contact
                  resolve:(RCTPromiseResolveBlock)resolve
                  reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(deleteUserContact:(NSString *)contactId
                  resolve:(RCTPromiseResolveBlock)resolve
                  reject:(RCTPromiseRejectBlock)reject)

RCT_EXTERN_METHOD(logout)


+ (BOOL)requiresMainQueueSetup
{
    return YES;
}

@end
